#include <stdio.h>
#include <stdlib.h>
#include <orb/orbit.h>

#include "DOM.h"

DOM_Document gdome_client;
DOM_Element element;
DOMString *str;

#if 0
char theblah[4096];
#endif

void
write_string (DOMString *str, FILE *f)
{
  int i;

  for (i = 0; i < str->_length; i++)
    fputc (str->_buffer[i], f);
}

int
main (int argc, char *argv[])
{
    CORBA_Environment ev;
    CORBA_ORB orb;
    CORBA_long rv;
    char buf[30];
    int i;

    int niters = 100;

    CORBA_exception_init(&ev);
    orb = CORBA_ORB_init(&argc, argv, "orbit-local-orb", &ev);

#if 0
    for(i = 0; i < (sizeof(theblah) - 1); i++)
	theblah[i] = 'a';
    theblah[sizeof(theblah) - 1] = '\0';
#endif

    if(argc < 2)
      {
	printf("Need a binding ID thing as argv[1]\n");
	return 1;
      }

    if(argc == 3)
	niters = atoi(argv[2]);

    gdome_client = CORBA_ORB_string_to_object(orb, argv[1], &ev);
    if (!gdome_client) {
	printf("Cannot bind to %s\n", argv[1]);
	return 1;
    }
#ifdef LOCATE_TEST
    ORBit_object_locate(gdome_client, &ev);
    if(ev._major != CORBA_NO_EXCEPTION) {
    	printf("Couldn't locate that object! (Exception %d)\n", ev._major);
	return(1);
    }
#endif
    for(i = 0; i < niters; i++) {
	    g_snprintf(buf, sizeof(buf), "Hello, world [%d]", i);
	    element = DOM_Document__get_documentElement (gdome_client, &ev);
	    if(ev._major != CORBA_NO_EXCEPTION) {
	      printf("we got exception %d from documentElement!\n", ev._major);
	      return 1;
	    }

	    str = DOM_Element__get_tagName (element, &ev);
	    if(ev._major != CORBA_NO_EXCEPTION) {
	      printf("we got exception %d from documentElement!\n", ev._major);
	      return 1;
	    }
	    write_string (str, stdout);

    }

    CORBA_Object_release(gdome_client, &ev);
    CORBA_Object_release((CORBA_Object)orb, &ev);

    return 0;
}
